#!/usr/bin/wish -f
proc stiv { name } { 
 if ![winfo exists .$name] then {  
global w
  set w .$name
  catch {destroy $w}
  toplevel $w
  wm title  $w "Study form"
  wm iconname $w "form"

global chtlb1 tlb1 chtlb2 tlb2 chtlb3 tlb3 font font1 f1 f2 f3 et1 et2 et3 line w mas tr1 ch1 ch2 ch3


set ch $w.chbt
frame $ch

checkbutton $ch.ch1 -text First  -variable ch1 -relief flat -command {if { $ch1 == 0} { set chtlb1 ""} else {set chtlb1 $tlb1}}
checkbutton $ch.ch2 -text Second -variable ch2 -relief flat -command {if { $ch2 == 0} { set chtlb2 ""} else {set chtlb2 $tlb2}}
checkbutton $ch.ch3 -text Third  -variable ch3 -relief flat -command {if { $ch3 == 0} { set chtlb3 ""} else {set chtlb3 $tlb3}}

set mn $w.check
menu $mn -tearoff 0

$mn add check -label First  -variable ch1 -command {if { $ch1 == 0} { set chtlb1 ""} else {set chtlb1 $tlb1}}
$mn add check -label Second -variable ch2 -command {if { $ch2 == 0} { set chtlb2 ""} else {set chtlb2 $tlb2}}
$mn add check -label Third  -variable ch3 -command {if { $ch3 == 0} { set chtlb3 ""} else {set chtlb3 $tlb3}}
 
bind $w <Button-3> [list tk_popup $mn %X %Y]

set ch1 1
set ch2 1
set ch3 1

pack $ch -fill x -side top
pack $ch.ch1 $ch.ch2 $ch.ch3 -padx 1m -pady 1m -side left

go

set i [expr int(1+[array size mas]*rand() )]

set line0 $mas($i)

set line [string range $line0 0 [expr [string first : $line0]-2 ] ]
set tr1 [string range $line0 [expr [string first : $line0]+2] [string length $line0]]

set tlb1 [string range $line 0 [expr [string first , $line]-2 ] ]
set tlb2 [string range $line [expr [string first , $line]+2] [expr [string last , $line]-2]]
set tlb3 [string range $line [expr [string last , $line]+2] [string length $line]]

if {$ch1 != 1} { set chtlb1 ""} else {set chtlb1 $tlb1}
if {$ch2 != 1} { set chtlb2 ""} else {set chtlb2 $tlb2}
if {$ch3 != 1} { set chtlb3 ""} else {set chtlb3 $tlb3}

set font {Courier 24 bold}
set font1 {Courier 14}

set f4 $w.f4
frame $f4
label $f4.lb1 -textvariable tr1 -font $font
pack $f4 -fill x -side bottom
pack $f4.lb1 -padx 1m -pady 1m

set f1 $w.f1
frame $f1
label $f1.lb1 -textvariable chtlb1 -font $font
entry $f1.et1 -textvariable et1 -font $font1

set f2 $w.f2
frame $f2
label $f2.lb2 -textvariable chtlb2 -font $font
entry $f2.et2 -textvariable et2 -font $font1

set f3 $w.f3
frame $f3
label $f3.lb3 -textvariable chtlb3 -font $font
entry $f3.et3 -textvariable et3 -font $font1

pack $f1 $f2 $f3 -side left
pack $f1.lb1 $f2.lb2 $f3.lb3 -padx 1m -pady 1m
pack $f1.et1 $f2.et2 $f3.et3 -padx 1m -pady 1m

focus $f1.et1
bind $f1.et1 <Return> {check}
bind $f2.et2 <Return> {check}
bind $f3.et3 <Return> {check}


} else { raise .$name } 
}

proc check {} {
global chtlb1 tlb1 chtlb2 tlb2 chtlb3 tlb3 f1 f2 f3 et1 et2 et3 file w mas tr1 ch1 ch2 ch3
if { $et1 != "" } {
if { $tlb1 != $et1 } {$f1.et1 configure -foreground red } else {$f1.et1 configure -foreground black; focus $f2.et2 }
}
if { $et2 != "" } {
if { $tlb2 != $et2 } {$f2.et2 configure -foreground red } else {$f2.et2 configure -foreground black; focus $f3.et3 }
}
if { $et3 != "" } {
if { $tlb3 != $et3 } {$f3.et3 configure -foreground red } else {$f3.et3 configure -foreground black; focus $f1.et1 }
}

if {($tlb1 == $et1) && ($tlb2 == $et2) && ($tlb3 == $et3)} { 
focus $f1.et1
set i [expr int(1+[array size mas]*rand())]
set line0 $mas($i)
set line [string range $line0 0 [expr [string first : $line0]-2 ] ]
set tr1 [string range $line0 [expr [string first : $line0]+2] [string length $line0]]

set tlb1 [string range $line 0 [expr [string first , $line]-2 ] ] 
set tlb2 [string range $line [expr [string first , $line]+2] [expr [string last , $line]-2]]
set tlb3 [string range $line [expr [string last , $line]+2] [string length $line]]

if {$ch1 != 1} { set chtlb1 ""} else {set chtlb1 $tlb1}
if {$ch2 != 1} { set chtlb2 ""} else {set chtlb2 $tlb2}
if {$ch3 != 1} { set chtlb3 ""} else {set chtlb3 $tlb3}


set et1 ""
set et2 ""
set et3 ""
}
}

proc go { } { 
global mas
set file [open iv-koi.txt]
set i 1
while {[gets $file line] != -1} {set mas($i) $line; set i [expr $i+1]}
close $file
}